/* This program is a demonstration of the QSORT routine. In this
   application, a structure array is sorted on one of several fields
   or "keys" within, based on the end-user's choice. Note the extensive
   use of pointers! */


#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>

struct student	{
		char first[25];
		char last[25];
		float gpa;
		};

/* 100 records are possible. IN stores the original data, OUT stores
	the data that will be sorted. */

struct student in[100],out[100];


int getlin( char *s, int max)
{
char c;
char *p;
int count=0;

for(p=s;;)
	  {
	  c=getch();  // read a char from kb

	  if ((c=='\b') && (count) )
		     {
		     count--;
		     p--;
		     putchar( c );
		     continue;
		     }

	  if (c=='\r')
		     {
		     *p = '\0';
		     putchar('\n');
		     return(count);
		     }

	  if ( (count >= max) || (c < ' ' ) ) continue;

	  *p=c;
	  p++;
	  putchar(c);
	  count++;
	  }
}



/* Display a record */

void display_record( struct student *record)
{
printf("\nName: %s, %s\nCGPA: %4.2f\n", record->last, record->first,
		record->gpa );
}

/* Input a record */

void input_record( struct student *record)
{
float *tc_bug;

printf("Student's Last Name ?");
getlin( record->last, 24 );
printf("Student's First Name?");
getlin( record->first, 24);


printf("Cum GPA?");
tc_bug=&(record->gpa ); /* Needed due to bug in Turbo C */
scanf( "%f", tc_bug );
}

/* Routine for comparing two last names within struct STUDENT */

int lname( const void *p1, const void *p2 )
{
return( strcmp( ((struct student*)p1)->last ,
	 ( (struct student*)p2 )->last ) );
}

/* Routine for comparing two first names within the structure */

int fname( const void *p1, const void *p2 )
{
return( strcmp( ((struct student*)p1)->first ,
	 ( (struct student*)p2 )->first ) );
}

/* Routine for comparing two GPAs in struct STUDENT  for QSORT */

int n_cmp( const void *p1, const void *p2)
{
struct student *v1, *v2;

v1 = (struct student*) p1;
v2 = (struct student*) p2;

if ( v1->gpa == v2->gpa ) return(0);
if ( v1->gpa > v2->gpa ) return(1);
return(-1);
}

/* The main program */

void main(void)
{
int number,i;
char key;

printf("How many records to work with?");
scanf("%d", &number );

for(i=0;i<number;i++)
	{
	printf("\nEnter record # %d\n", i+1 );
	input_record( &in[i] );
	}

/* Display Loop */

for(;;)
	{
	/* Dump data into "sortable" array while retaining original data. */

	for(i=0;i<number;i++) out[i]=in[i];

	printf("\nChoose sort key:\n\n(1) FIRST name\n(2) LAST name\n(3) GPA\n\n?");

	key=getch();

	switch( key)
		{
		case '1': qsort( out, number, sizeof( out[0] ), fname);
			  break;

		case '2': qsort( out, number, sizeof( out[0] ), lname);
			  break;

		case '3': qsort( out, number, sizeof( out[0] ), n_cmp );
			  break;

		case 27: exit(0);

		default: printf("\nOriginal Data Restored:\n");
		}

	printf("\nSorted Array:\n");
	for(i=0;i<number;i++)
		{
		display_record( &out[i] );
		if ( ((i+1)%10) == 0)	{
					printf("\n\nPress a key...\n\n");
					getch();
					}
		}
	}
}