/*                    SORT4.C

	This is an example of a sorted list.  The procedure used is
	QUICK SORT (QSORT), which is part of the ANSI C library.
	It is an advanced sort routine for high-performance sort
	applications. */



#include <stdio.h>
#include <string.h>
#include <stdlib.h>


#define MAX 50			/* maximum array row subscript value +1 */
char strings[MAX][80];	/* array of 50 x 80, enough for 50 items */
int entries;			/* counter for number of entries */

int strcmp();			/* define STRCMP for compiler */

void main()
{
int i;


printf("\n\nThis is an example of a QUICKSORT.\n\
You are to enter up to 50 items you want sorted.  Press RETURN\n\
on a blank line to begin the sorting procedure.\n\n");

entries=-1;			/* flag for NO entries */

for(i=0;i<MAX;i++)	{
					printf("Item #%3d : ",i+1);	/* print user PROMPT */
					gets(strings[i]);	/* get each string */

					if (strings[i][0] == 0)	break;	/* bust out if last one*/

					entries++;	/* else, update entry counter & continue */
					}


/* Check for NO entries condition--no need to do anything if so */

if (entries== -1)	return;	/* blast outta here, nothing to do */

printf("\n\nSorting %d entries...",entries+1);


/* Do the quicksort procedure.  Note carefully how the library routine
   is called: */


qsort(strings,entries+1,sizeof(strings[0]),&strcmp );

/*        Parameters passed to QSORT are as follows: 

   STRINGS = address of array to sort,

   ENTRIES + 1 = the actual number of items in the array,

   SIZEOF(strings[0]) = the WIDTH or SIZE of each array element,

   &STRCMP = the ADDRESS of the COMPARISON routine that QSORT() will
             call to compare each element.  Since this is to be a string
             sort, STRCMP() is used. QSORT passes pointers to the two
             items to be compared when it calls the compare routine. */




printf("done.  Here is the sorted list:\n");

for(i=0;i<=entries;i++)	
				printf("\nItem #%3d : %s",i+1,strings[i]);


printf("\n\nThat's all, folks!\n");

}

